<div class="p-15">
  <sqtm-core-compact-collapse-panel
    [attr.data-test-element-id]="'action-panel'"
    [i18nTitleKey]="
      execution.kind === 'GHERKIN'
        ? 'sqtm-core.entity.test-step.script'
        : 'sqtm-core.entity.test-step.action.singular'
    "
  >
    <div
      class="m-l-10"
      [attr.data-test-element-id]="'execution-step-action'"
      [innerHTML]="action | safeRichContent"
    ></div>
  </sqtm-core-compact-collapse-panel>

  @if (execution.kind === 'STANDARD') {
    <sqtm-core-compact-collapse-panel
      [attr.data-test-element-id]="'result-panel'"
      [i18nTitleKey]="'sqtm-core.entity.test-step.expected-result.label'"
    >
      <div
        class="m-l-10"
        [attr.data-test-element-id]="'execution-step-expected-result'"
        [innerHTML]="expectedResult | safeRichContent"
      ></div>
    </sqtm-core-compact-collapse-panel>
  }

  @if (shouldShowInformationPanel()) {
    <sqtm-core-compact-collapse-panel
      [attr.data-test-element-id]="'information-panel'"
      [i18nTitleKey]="'sqtm-core.generic.label.information.plural'"
    >
      <div class="m-l-10 entity-information-grid-one-column">
        @if (execution.datasetLabel) {
          <label class="txt-ellipsis">
            {{ 'sqtm-core.entity.dataset.label.singular' | translate }}
          </label>
        }
        @if (execution.datasetLabel) {
          <span [attr.data-test-element-id]="'execution-prologue-dataset'">
            {{ execution.datasetLabel }}
          </span>
        }
        @for (
          dfv of currentStep.denormalizedCustomFieldValues;
          track dfv;
          let index = $index
        ) {
          <div class="flex-row overflow-hidden">
            <label
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.campaign-workspace.execution-runner.dnz-step-cuf.tooltip'
                  | translate
              "
              [attr.data-test-element-id]="
                'execution-prologue-dnz-label-' + index
              "
              class="txt-ellipsis"
            >
              {{ dfv.label }}
            </label>
            <label class="m-l-3">*</label>
          </div>
          <sqtm-app-denormalized-custom-field
            [denormalizedFieldValue]="dfv"
            class="overflow-hidden"
          ></sqtm-app-denormalized-custom-field>
        }
        @if (this.execution.kind === 'STANDARD') {
          @for (customField of customFields; track customField) {
            <label>{{ customField.label }}</label>
            <div class="overflow-hidden">
              <sqtm-core-custom-field-widget
                [targetOnUpload]="{
                  entityId: currentStep.id,
                  attachmentListId: currentStep.attachmentList.id,
                  holderType: AttachmentHolderType.EXECUTION_STEP
                }"
                [customField]="customField"
                [value]="getCfvValue(customField)"
                [editable]="
                  permissions.canExecute && milestonesAllowModification
                "
                (confirmEvent)="updateCustomFieldValue(customField, $event)"
              >
              </sqtm-core-custom-field-widget>
            </div>
          }
        }
      </div>
    </sqtm-core-compact-collapse-panel>
  }

  <sqtm-core-compact-collapse-panel
    [attr.data-test-element-id]="'comment-panel'"
    [i18nTitleKey]="'sqtm-core.entity.execution.comment'"
  >
    <sqtm-core-editable-rich-text
      [attr.data-test-field-id]="'comment'"
      [value]="currentStep.comment"
      [focus]="true"
      [targetOnUpload]="{
        entityId: currentStep.id,
        attachmentListId: currentStep.attachmentList.id,
        holderType: AttachmentHolderType.EXECUTION_STEP
      }"
      [editable]="permissions.canExecute && milestonesAllowModification"
      (confirmEvent)="changeComment($event)"
    >
    </sqtm-core-editable-rich-text>
  </sqtm-core-compact-collapse-panel>

  <sqtm-core-compact-collapse-panel
    [i18nTitleKey]="'sqtm-core.entity.attachment.label.long.plural'"
  >
    <sqtm-core-attachment-list-compact
      [attachmentListId]="currentStep.attachmentList.id"
      [attachments]="attachments"
      [canAttach]="permissions.canAttach && milestonesAllowModification"
      (deleteAttachmentEvent)="deleteAttachmentEvent($event)"
      (cancelDeleteAttachmentEvent)="cancelDeleteAttachment($event)"
      (confirmDeleteAttachmentEvent)="confirmDeleteAttachment($event)"
      (removeRejectedAttachmentEvent)="removeRejectedAttachment($event)"
    >
    </sqtm-core-attachment-list-compact>
    <div projection="toolbar" class="full-height m-t-4 m-r-8 collapse-toolbar">
      <sqtm-core-toggle-icon
        class="current-workspace-button"
        [active]="permissions.canAttach && milestonesAllowModification"
        (clickedInActiveMode)="browseForAttachment()"
      >
        <i
          nz-icon
          class="table-icon-size m-auto"
          nzType="sqtm-core-generic:add"
          [nzTheme]="'outline'"
        >
        </i>
      </sqtm-core-toggle-icon>
    </div>
  </sqtm-core-compact-collapse-panel>

  @if (bugTracker$ | async; as bugTracker) {
    <sqtm-core-compact-collapse-panel
      [attr.data-test-element-id]="'issues-panel'"
      [i18nTitleKey]="'sqtm-core.entity.issue.label.plural'"
    >
      <sqtm-app-execution-step-issues
        #issuesPanel
        [execution]="execution"
        (authenticated)="notifyIsAuthenticatedInBugTracker()"
      >
      </sqtm-app-execution-step-issues>
      <div
        projection="toolbar"
        class="full-height m-t-4 m-r-8 collapse-toolbar"
      >
        <sqtm-core-toggle-icon
          class="current-workspace-button"
          [active]="canReportIssue"
          [attr.data-test-button-id]="'report-issue'"
        >
          <i
            nz-icon
            nz-dropdown
            [nzDropdownMenu]="issuesMenu"
            [nzDisabled]="!canReportIssue"
            nzType="sqtm-core-generic:add"
            nzTheme="outline"
            class="table-icon-size m-auto"
            [attr.data-test-toolbar-button-id]="'create-button'"
          >
          </i>
        </sqtm-core-toggle-icon>
        <sqtm-core-toggle-icon
          class="current-workspace-button"
          [active]="issuesTableService.hasSelectedRows$ | async"
          (clickedInActiveMode)="unlinkSelectedIssues($event)"
        >
          <i
            nz-icon
            class="table-icon-size m-auto"
            nzType="sqtm-core-generic:unlink"
            [nzTheme]="'outline'"
            [nz-tooltip]="
              'sqtm-core.campaign-workspace.execution-page.dialog.title.remove-issue.delete-many'
                | translate
            "
          >
          </i>
        </sqtm-core-toggle-icon>
      </div>
    </sqtm-core-compact-collapse-panel>
  }
</div>

<sqtm-core-attachment-file-selector
  (uploadFilesEvent)="handleAddAttachments($event)"
>
</sqtm-core-attachment-file-selector>

<nz-dropdown-menu #issuesMenu="nzDropdownMenu">
  <ul nz-menu [attr.data-test-menu-id]="'issues-menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'create-issue'"
      (click)="openReportIssueDialog(false)"
    >
      {{
        'sqtm-core.campaign-workspace.dialog.title.report-new-issue' | translate
      }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'attach-issue'"
      (click)="openReportIssueDialog(true)"
    >
      {{ 'sqtm-core.campaign-workspace.dialog.title.attach-issue' | translate }}
    </li>
  </ul>
</nz-dropdown-menu>
